package com.gk_software.core.maven.mojo;

public class ArtifactItem {

    private ArtifactItem artifactItem;

    private String groupId;

    private String artifactId;

    private String classifier;

    private String oldVersion;

    private String newVersion;


    public ArtifactItem() {
    }

    public ArtifactItem(String groupId, String artifactId, String oldVersion, String newVersion) {
        this.groupId = groupId;
        this.artifactId = artifactId;
        this.oldVersion = oldVersion;
        this.newVersion = newVersion;
        this.classifier = "sources";
    }

    public ArtifactItem(String groupId, String artifactId, String classifier, String oldVersion, String newVersion) {
        this.groupId = groupId;
        this.artifactId = artifactId;
        this.classifier = classifier;
        this.oldVersion = oldVersion;
        this.newVersion = newVersion;
    }

    public ArtifactItem(ArtifactItem item) {
        setArtifactItem(item);
        setGroupId(item.groupId);
        setArtifactId(item.artifactId);
        setOldVersion(item.oldVersion);
        setNewVersion(item.newVersion);
        if (item.classifier != null){
            setClassifier(item.classifier);
        }else{
            setClassifier("sources");
        }
    }

    public ArtifactItem getArtifactItem() {
        return artifactItem;
    }

    public String getGroupId() {
        return groupId;
    }

    public void setGroupId(String groupId) {
        this.groupId = groupId;
    }

    public String getArtifactId() {
        return artifactId;
    }

    public void setArtifactId(String artifactId) {
        this.artifactId = artifactId;
    }

    public String getClassifier() {
        return classifier;
    }

    public void setArtifactItem(ArtifactItem artifactItem) {
        this.artifactItem = artifactItem;
    }

    public void setClassifier(String classifier) {
        this.classifier = classifier;
    }

    public String getOldVersion() {
        return oldVersion;
    }

    public void setOldVersion(String oldVersion) {
        this.oldVersion = oldVersion;
    }

    public String getNewVersion() {
        return newVersion;
    }

    public void setNewVersion(String newVersion) {
        this.newVersion = newVersion;
    }
}
