package com.gk_software.core.maven.mojo;

import org.apache.logging.log4j.Logger;
import org.apache.maven.plugin.MojoExecutionException;
import org.apache.maven.plugin.MojoFailureException;
import org.apache.maven.plugins.annotations.LifecyclePhase;
import org.apache.maven.plugins.annotations.Mojo;
import org.apache.maven.plugins.annotations.Parameter;
import com.gk_software.core.maven.parser.DoinFile;
import com.gk_software.core.maven.utils.ClassData;
import com.gk_software.core.maven.utils.ModificationHelper;

import java.io.*;
import java.util.Hashtable;
import java.util.LinkedList;

@Mojo(name = "check-doin", defaultPhase = LifecyclePhase.INSTALL)
public class CheckDoin extends AbstractExecution {

    @Parameter(required = false, defaultValue = "")
    private String excludes;

    private static final String suffix = ".doin";

    private static Logger logger;

    private String[] regExExcludes = null;

    private int possibleError = 0;

    private Hashtable<String, ClassData> hashtable = new Hashtable<>();


    @Override
    public void execute() throws MojoExecutionException, MojoFailureException {
        getLog().info("'check-doin' is not implemented");
//        CustomConfigurationFactory.createFileName("check-doin", this.getOutput());
//        logger = LogManager.getLogger(OverwrittenFiles.class.getName());
//        if ((!this.checkProductData()) || (!this.checkProjectData())) {
//            return;
//        }
//        if (this.excludes != null) this.regExExcludes = ModificationHelper.strToRegex(excludes);
//
//        String[] suffixes = {suffix};
//        LinkedList<File> projectDoinFiles = ModificationHelper.filterFiles(this.getAllFilesFromMain(), suffixes, null);
//        if (projectDoinFiles.size() == 0){
//            logger.warn("There were not found any '.doin' files in project");
//            getLog().warn("There were not found any '.doin' files in project");
//            return;
//        }
//        getLog().info("Doin files count: " + projectDoinFiles.size());
//        LinkedList<DoinFile> doinFiles = getDoinWithSuperClass(projectDoinFiles);
//        if (doinFiles.size() == 0){
//            logger.info("There were not found any '.doin' files with superclass");
//            getLog().info("There were not found any '.doin' files with superclass");
//            return;
//        }
//
//        suffixes = new String[]{".do"};
//        LinkedList<File> oldProductDoFiles = ModificationHelper.filterFiles(this.getOldVersionFiles(), suffixes, this.regExExcludes);
//        if (oldProductDoFiles.size() == 0){
//            logger.info("There were not found any '.do' files in old version product");
//            getLog().info("There were not found any '.do' files in old version product");
//            return;
//        }
//
//        LinkedList<File> changedDoFiles = ModificationHelper.filterFiles(this.getChangedProductFiles(), suffixes, this.regExExcludes);
////        for (File f: changedDoinFiles){
////            System.out.println(f.getAbsolutePath());
////        }
//        LinkedList<File> projectDoFiles = ModificationHelper.filterFiles(this.getAllFilesFromMain(), suffixes, null);
//        for (DoinFile doinFile: doinFiles){
//            chechRegerence(doinFile, oldProductDoFiles, changedDoFiles, projectDoFiles);
//        }
//
//        getLog().info("Number of possible problems in projects '.doin' files: "+possibleError);
//        printHashTable();

    }

    private void printHashTable() {
        for (String key : hashtable.keySet()) {
            logger.info(ModificationHelper.getLineFromHashTable(key, hashtable.get(key)));
        }
    }

    private void chechRegerence(DoinFile doinFile, LinkedList<File> oldProductDoinFiles, LinkedList<File> changedDoinFiles, LinkedList<File> projectDoFiles) {
//        Stack<String> stack = new Stack<>();
//        stack.push(doinFile.getSuperClass());
//        String doinRelativePath = ModificationHelper.getPathFromString(doinFile.getFile().getAbsolutePath(), this.getProjectSourcePath().replace("\\java", ""));
////        System.out.println("--------------");
////        System.out.println(doinFile.getFile().getName());
////        for (String filePath: doinFile.getReferences()){
////            System.out.println(filePath);
////        }
//        while (!stack.empty()) {
//            String path = stack.pop();
//            File oldFile = locateFile(path, oldProductDoinFiles);
//            if (oldFile == null) {
//                File projectFile = locateFile(path, projectDoFiles);
//                if (projectFile == null) {
//                    ModificationHelper.addToHashTable(hashtable, path, doinRelativePath, "file not found");
//                    possibleError++;
//                    return;
//                } else {
//                    try {
//                        DoFile tmpDo = new DoFile(projectFile);
//                        if (tmpDo.getSuperClass() != null) {
//                            stack.add(tmpDo.getSuperClass());
//                        }
//                    } catch (IOException e) {
//                        e.printStackTrace();
//                    }
//                }
//            } else {
//                if (checkIfChanged(hashtable, doinRelativePath, path, changedDoinFiles)) {
//                    possibleError++;
//                }
//                try {
//                    DoFile tmpDo = new DoFile(oldFile);
//                    if (tmpDo.getSuperClass() != null) {
//                        stack.push(tmpDo.getSuperClass());
//                    }
//                } catch (IOException e) {
//                    System.out.println(e.getMessage());
//                }
//            }
//
//        }

    }

    private File locateFile(String path, LinkedList<File> oldProductDoinFiles) {
        for (File f : oldProductDoinFiles) {
            if (f.getName().equals(path)) {
                return f;
            }
        }
        return null;
    }

    private LinkedList<DoinFile> getDoinWithSuperClass(LinkedList<File> projectDoinFiles) {
        LinkedList<DoinFile> doinFiles = new LinkedList<>();
        for (File f : projectDoinFiles) {
            try {
                DoinFile tmpDoin = new DoinFile(f);
                if (tmpDoin.getSuperClass() != null) {
                    doinFiles.add(tmpDoin);
                }
            } catch (IOException e) {
                System.out.println(e.getMessage());
            }
        }
        return doinFiles;
    }
}
