package com.gk_software.core.maven.parser;

import java.io.File;
import java.io.IOException;
import java.util.regex.Pattern;

public class DoFile extends AbstractParser{

    private static final Pattern CLASS_PATTERN = Pattern.compile("((?:master entity))\\s([a-zA-Z0-9_\\-.]+)");
    private static final Pattern EXTENDS_PATTERN = Pattern.compile("(?:master entity)\\s([a-zA-Z0-9_\\-.]+)\\s(?:extends)\\s([a-zA-Z0-9_\\-.]+)");
    private static final String SUFFIX = ".do";


    public DoFile(File file) throws IOException {
        super(file);
    }

    @Override
    protected String getSuperClassFromLine(String group) {
        String[] tokens = group.split("extends");
        return tokens[1].trim();
    }

    @Override
    protected String addSuperClassPath(String superClass) {
        return superClass + getSuffix();
    }

    @Override
    protected Pattern extendsPattern() {
        return EXTENDS_PATTERN;
    }

    @Override
    protected Pattern getClassPattern() {
        return CLASS_PATTERN;
    }

    @Override
    protected String getSuffix() {
        return SUFFIX;
    }
}
