package com.gk_software.core.maven.parser;

import java.io.File;
import java.io.IOException;
import java.util.regex.Pattern;

public class PromoJFile extends AbstractParser {

    private static final Pattern CLASS_PATTERN = Pattern.compile("((?:Process))\\s([a-zA-Z0-9_\\-.]+)");
    private static final Pattern EXTENDS_PATTERN = Pattern.compile("(?:Process)\\s([a-zA-Z0-9_\\-.]+)\\s(?:specializes)\\s([a-zA-Z0-9_\\-.]+)");
    private static final String SUFFIX = ".promoj";

    public PromoJFile(File file) throws IOException {
        super(file);
    }

    @Override
    protected String getSuperClassFromLine(String group) {
        String[] tokens = group.split("specializes");
        return tokens[1].trim();
    }


    @Override
    protected Pattern extendsPattern() {
        return EXTENDS_PATTERN;
    }

    @Override
    protected Pattern getClassPattern() {
        return CLASS_PATTERN;
    }

    @Override
    protected String getSuffix() {
        return SUFFIX;
    }
}
