package com.gk_software.core.maven.utils;

import org.apache.logging.log4j.Level;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.apache.logging.log4j.core.Appender;
import org.apache.logging.log4j.core.Filter;
import org.apache.logging.log4j.core.LoggerContext;
import org.apache.logging.log4j.core.appender.ConsoleAppender;
import org.apache.logging.log4j.core.appender.RollingFileAppender;
import org.apache.logging.log4j.core.appender.rolling.DefaultRolloverStrategy;
import org.apache.logging.log4j.core.appender.rolling.SizeBasedTriggeringPolicy;
import org.apache.logging.log4j.core.config.*;
import org.apache.logging.log4j.core.config.plugins.Plugin;
import org.apache.logging.log4j.core.layout.PatternLayout;


@Plugin(name = "CustomConfigurationFactory", category = ConfigurationFactory.CATEGORY)
@Order(50)
public class CustomConfigurationFactory {
    public static Logger getLogger(String parameter){
        final LoggerContext ctx = (LoggerContext) LogManager.getContext(false);
        final Configuration config = ctx.getConfiguration();

        SizeBasedTriggeringPolicy policy = SizeBasedTriggeringPolicy.createPolicy("10MB");
        DefaultRolloverStrategy strategy = DefaultRolloverStrategy.createStrategy("20", "1", null, null, null, false, config);
        PatternLayout layout = PatternLayout.newBuilder().withConfiguration(config).withPattern("[%p] %C{1} -> %m%n").build();

        Appender appender = RollingFileAppender.createAppender(parameter+".log", parameter+"-%i.log",
                "true", parameter, "true", "128", "true", policy, strategy, layout, (Filter) null, "false", "false", (String) null, config);

        appender.start();
        config.addAppender(appender);

        AppenderRef ref = AppenderRef.createAppenderRef(parameter, null, null);
        AppenderRef[] refs = new AppenderRef[] {ref};
        LoggerConfig loggerConfig = LoggerConfig.createLogger(false, Level.INFO, parameter, "true", refs, null, config, null );
        loggerConfig.addAppender(appender, null, null);
        config.addLogger(parameter, loggerConfig);
        ctx.updateLoggers();
        return LogManager.getLogger(parameter);
    }
}
