package com.gk_software.core.maven.utils;

import java.io.File;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.Hashtable;
import java.util.LinkedList;

public class ModificationHelper {

    public static Path getRelativePath(String fileFullPath, String fileDirectory){
        Path absolutePath1 = Paths.get(fileFullPath);
        Path absolutePath2 = Paths.get(fileDirectory);
        return absolutePath2.relativize(absolutePath1);
    }

    public static boolean isAmongExcludes(String[] excludes, String path){
        if (excludes == null){
            return false;
        }
        for (String exclude: excludes){
            if (path.contains(exclude)){
                return true;
            }
        }
        return false;
    }

    public static String[] excludesIntoPath(String exclude){
        String[] tokens= exclude.split(",");
        for (int i = 0; i < tokens.length; i++) {
            tokens[i] = tokens[i].trim();
            tokens[i] = "\\" + tokens[i].replace(".", "\\");
        }
        return tokens;
    }

    public static String[] strToRegex(String attribute) {
        String[] tokens = attribute.split(",");
        for (int i = 0; i < tokens.length; i++) {
            tokens[i] = tokens[i].trim();
            if (tokens[i].charAt(0) == '*') {
                tokens[i] = tokens[i].substring(1);
            }
        }
        return tokens;
    }

    public static String getPathFromPackage(String packagePath){
        return "\\" +
                packagePath.replace(".", "\\");
    }

    public static String getPathFromPackage(String packagePath, String suffix) {
        return "\\" +
                packagePath.replace(".", "\\") +
                suffix;
    }

    public static String getPathFromPackage(String packagePath, String prefix, String suffix) {
        return prefix+"\\" +
                packagePath.replace(".", "\\") + "."+
                suffix;
    }

    public static LinkedList<File> filterFiles(LinkedList<File> files, String suffix){
        LinkedList<File> filteredFiles = new LinkedList<>();
        for (File f : files){
            if (f.getAbsolutePath().endsWith(suffix)){
                filteredFiles.add(f);
            }
        }
        return filteredFiles;
    }
    public static LinkedList<File> filterFiles(LinkedList<File> files, String[] suffix){
        LinkedList<File> filteredFiles = new LinkedList<>();
        for (File f : files){
            for (String s: suffix){
                if (f.getAbsolutePath().endsWith(s)){
                    filteredFiles.add(f);
                    break;
                }
            }
        }
        return filteredFiles;
    }

//    public static LinkedList<File> filterFiles(LinkedList<File> files, String[] fileSuffixes, String[] excludes){
//        LinkedList<File> filteredFiles = new LinkedList<>();
//        for (File f : files){
//            if (checkIncludesExcludes(f.getAbsolutePath(), fileSuffixes, excludes)){
//                filteredFiles.add(f);
//            }
//        }
//
//        return filteredFiles;
//    }

    public static String getPathFromString(String absolutePath, String splitFrom) {
        return absolutePath.replace(splitFrom, "");
    }

//    private static boolean checkIncludesExcludes(String name, String[] fileSuffixes, String[] excludes){
//        if (fileSuffixes != null){
//            for (String regex: fileSuffixes){
//                if (name.endsWith(regex)){
//                    return checkExcludes(name, excludes);
//                }
//            }
//            return false;
//        }
//        return checkExcludes(name, excludes);
//    }

//    private static boolean checkExcludes(String name, String[] excludes) {
//        if (excludes != null){
//            for (String regex : excludes){
//                if (name.endsWith(regex)){
//                    return false;
//                }
//            }
//        }
//        return true;
//    }

    public static String getLineFromHashTable(String key, ClassData classData){
            StringBuilder sb = new StringBuilder();
            for (String s : classData.getClasses()){
                sb.append("\n \t");
                sb.append(s);
            }
        return key + " - "+ classData.getMessage() + " -->" + sb.toString();
    }

    public static void addToHashTable(Hashtable<String, ClassData> hashtable, String key, String value, String message){
        if (!hashtable.containsKey(key)) {
            hashtable.put(key, new ClassData(message, value));
            return;
        }
        hashtable.get(key).getClasses().add(value);
    }



}
