dslLevel 2
Package com.gk_software.cst.pos.client.model.config.do_types.pos_process

Import com.gk_software.cst.pos.client.model.config.do_types.pos_process.PayInOutItemConfig_EXT.PayInOutItemConfigDO_EXT
Import com.gk_software.cst.pos.client.model.config.do_types.pos_process.PayInOutItemEntryConfig_CST.PayInOutItemEntryConfigDO_CST
Import com.gk_software.pos.api.model.config.do_types.processes.ui.DialogConfig_DO.PromptUserDialogConfig
Import com.gk_software.pos.api.model.config.do_types.processes.actions.PositionOperationConfig_DO.PositionOperationConfig
Import com.gk_software.pos.api.model.config.do_types.processes.flows.ProcessConfig_DO.ProcessConfig
Import com.gk_software.pos.api.model.config.do_types.processes.actions.PaymentOperationConfig_DO.PaymentOperationConfig

Import com.gk_software.pos.api.model.app.AbstractEntity_DO.AbstractEntity
Import common.Integer


domain object BadgeConfigs_CST {
  version "1.0"

  entity BadgeCommonConfigDO_CST extends AbstractEntity {

    /$ String with Reason Codes for the pay-out disbursement line items for the badge (separated by semicolon) $/
    attribute badgePayOutReason : String

    /$ String with Reason Codes for the pay-in line item for the badge $/
    attribute badgePayInReason : String

    /$ Item EAN for the badge pay-in line item $/
    attribute badgePayInItemEan : String

    /$ Item EAN for the badge pay-out line item $/
    attribute badgePayOutItemEan : String

    /$ Assignment of the badge tender saved in the table Tender $/
    attribute badgeTenderTypeCode : String
  }

  /$ Config for badge booking process. $/
  entity BadgeBookingConfigDO_CST extends ProcessConfig {
    /$ Badge booking sum $/
    attribute bookingAllSum : String
    /$ Badge booking sum sign define was booking sum positive or negative $/
    attribute bookingAllSumSign : BookingSumSign_CST
    /$ Badge common config instance from bundle $/
    attribute badgeCommonConfig : BadgeCommonConfigDO_CST
    /$ MessageKey for termination dialog in case of positive booking sum $/
    attribute bookTerminatedSumMoreMessageKey : String
    /$ MessageKey for termination dialog in case of negative booking sum $/
    attribute bookTerminatedSumLessMessageKey : String
  }

  /$ Config for payment with badge process. $/
  entity BadgePaymentConfigDO_CST extends ProcessConfig {

    /$  The payment operation config for the badge payment action $/
    required attribute badgePaymentOperationConfig : BadgePaymentOperationConfigDO_EXT

    /$  Badge common config contein badge items credits $/
    required attribute badgeCommonConfig : BadgeCommonConfigDO_CST

    /$  The position operation config for the badge payment action $/
    required attribute positionOperationConfig : PositionOperationConfig

    /$  The config for the prompt for cash payment amount dialog $/
    required attribute promptForAmountConfig : PromptUserDialogConfig

    /$ Payment amount to be used by the function (internal parameter) $/
    attribute amount : Integer

    /$  0 - drawer is never opened
          1 - drawer is opened if Tender.OpenCashDrawerRequiredFlag==true $/
    attribute drawerOpen : Integer

    /$ Global parameter (PAYMENT_PROCESS).
         Defines the procedure in case of overpayment:
          0 – the money back is always paid in cash
          1 – if the cash back amount is greater than the amount of the “cash” tender used,
              the tender to be paid out must be selected    $/
    attribute backMoneyAction : Integer

    /$  Determines whether a WarnDialog is displayed when
          a badge pay in/pay out position exists in the transaction.
            true -  WarnDialog is displayed.
            false - WarnDialog is not displayed, but function is aborted. $/
    attribute displayWarnDialogBadgePayInOutPosition : boolean

  }

  /$ Config for badge payment process. $/
  entity BadgePaymentOperationConfigDO_EXT extends PaymentOperationConfig { }

  /$ Config for BadgeItemEntry_CST process. $/
  entity BadgeItemEntryConfigDO_CST extends PayInOutItemEntryConfigDO_CST {

    /$ Amount to be used by the function (internal parameter) $/
    attribute amount : double
    /$ Item number (EAN) $/
    attribute itemEAN : String
    //      /$ Type of the "Einzahlungsgründe" $/
    //      required attribute reasonTypePayIn : String
    //      /$ Type of the "Auszahlungsgründe" $/
    //      required attribute reasonTypePayOut : String
    /$  Amount for the badge payIn / payOut line item $/
    attribute badgeAmount : double

    /$  The badge common config  $/
    attribute badgeCommonConfig : BadgeCommonConfigDO_CST

    /$ PayInOutType $/
    attribute payInOutType : BadgePayInOutItemType_CST

  }

  /$ Config for BadgePayInOutItem_CST process. $/
  entity BadgePayInOutItemConfigDO_CST extends PayInOutItemConfigDO_EXT {

    /$  The badge common config  $/
    required attribute badgeCommonConfig : BadgeCommonConfigDO_CST

  }

  /$ Config for BadgeSaldoCheck_CST process. $/
  entity BadgeSaldoCheckConfigDO_CST extends ProcessConfig {

    /$  The badge amount $/
    attribute badgeAmount : String

    /$  The badge common config  $/
    attribute badgeCommonConfig : BadgeCommonConfigDO_CST
  }

  entity BadgeVoidingConfigDO_CST extends ProcessConfig {
    /$ Badge booking sum $/
    attribute bookingAllSum : String
    /$ Badge booking sum sign define was booking sum positive or negative $/
    attribute bookingAllSumSign : BookingSumSign_CST
    /$ Badge common config instance from bundle $/
    attribute badgeCommonConfig : BadgeCommonConfigDO_CST
    /$ MessageKey for termination dialog in case of positive booking sum $/
    attribute bookTerminatedSumMoreMessageKey : String
    /$ MessageKey for termination dialog in case of negative booking sum $/
    attribute bookTerminatedSumLessMessageKey : String
    /$ This (input) parameter decides whether a badge pay-in/pay-out item
         OR a badge tender line item is voided:
              if voidingType = "ITEM" → badge pay-in/pay-out item
              if voidingType = "TENDER" → badge tender line item    $/
    attribute voidingType : String
  }

  typedef BadgePayInOutItemType_CST : enum with type String [
    BADGE_PAY_IN_LINEITEM as "BADGE_PAY_IN_LINEITEM",
    BADGE_PAY_OUT_LINEITEM as "BADGE_PAY_OUT_LINEITEM" ]

  typedef BookingSumSign_CST : enum with type String [
    PLUS as "PLUS",
    MINUS as "MINUS" ]

}
