dslLevel 2

Package com.gk_software.cst.pos.client.model.config.do_types.pos_process
Import com.gk_software.pos.api.model.config.do_types.processes.actions.PositionOperationConfig_DO.PositionOperationConfig


Import com.gk_software.pos.api.model.config.do_types.processes.ui.DialogConfig_DO.MessageDialogConfig
Import com.gk_software.cst.pos.client.model.config.do_types.pos_process.CustomerRegistrationConfig_EXT.CustomerOperationConfigDO_EXT
Import com.gk_software.cst.pos.client.model.config.do_types.pos_process.EnterCouponConfig_EXT.EnterCouponConfigDO_EXT
Import com.gk_software.pos.api.model.app.AbstractEntity_DO.AbstractEntity
Import com.gk_software.pos.api.model.config.do_types.processes.flows.ProcessConfig_DO.ProcessConfig
Import common.common_types.v1_0_0.DescriptionShort
Import common.common_types.v1_0_0.IdentityAlphaNumeric40

domain object CustomerCardConfigs_CST {
  version "1.0"

  master entity SupercardRegistrationConfigDO_CST extends ProcessConfig {

  /$ Defines whether the function must be started with customer card number as input parameter or not
       True: customer card number is mandatory input for the function call
       False: customer card number is not needed for the function call $/
    attribute customerRequired : boolean

    /$ It specifies whether the customer number can be entered manually. $/
    attribute manualInput : boolean

    /$ Determines whether a message is displayed when the customer card has been registered. $/
    attribute showRegistrationMessage : boolean

    /$ Determines whether the supercard was registered from a digital source (e.g. TWINT) $/
    attribute isDigitalSource : boolean

    /$ Specifies the Channel during the webservice call for bonus points $/
    attribute channel : String

    /$ Determines the timeout when calling the supercard webservice.
       Depending on the POS state, it can be configured differently. $/
    attribute supercardWSTimout : String

    /$ Default customer number $/
    attribute defaultCustomerId : String

    /$ Default customer group, global parameter$/
    attribute defaultCustomerGroup : String

    /$ Customer operation configuration $/
    attribute customerOperationConfig : CustomerOperationConfigDO_EXT

    /$ Bonus points web adapter configuration $/
    attribute bonusPointsAdapterConfig : String
    
    /$ Trust level web adapter configuration $/
    attribute trustLevelAdapterConfig : String
    
    /$ WS is called in background $/
    attribute runInBackground : boolean

    /$ Determines whether the discarding function is allowed $/
    attribute discardingAllowed : boolean

    /$ Default customer is used $/
    attribute useDefaultCustomer : boolean

    /$ Configuration Id of discard customer card batch process $/
    attribute discardCustomerBatchConfigId : String with default "DiscardCustomerBatchConfigs_CST.Default"

    /$ Message dialog config: function not allowed $/
    attribute functionNotAllowedMessageDialogConfig : MessageDialogConfig

    /$ Message dialog config: tender line exits $/
    attribute tenderLineExistsMessageDialogConfig : MessageDialogConfig

    /$ Message dialog config: manual entry not allowed $/
    attribute manualEntryNotAllowedMessageDialogConfig : MessageDialogConfig

    /$ Message dialog config: card already registered $/
    attribute cardAlreadyRegisteredMessageDialogConfig : MessageDialogConfig

    /$ Message dialog config: card missing $/
    attribute cardMissingMessageDialogConfig : MessageDialogConfig

    /$ Message dialog config: card registered successfully $/
    attribute cardRegisteredMessageDialogConfig : MessageDialogConfig
    
   /$ Message dialog config: ssc transaction $/
    attribute sSCTransactionMessageDialogConfig : MessageDialogConfig

    /$ List of sources that came from EIQ $/
    attribute eiqSourceList       : String[0..*] indistinct

    /$ Config for registration of digital coupons $/
    attribute digitalCouponRegistrationConfig : EnterCouponConfigDO_EXT

    /$ defines whether it is also allowed to register Supercard manually or only via scanner $/
    attribute registrationWithManualInputAllowed : boolean

    /$ defines the number of invalid SC cards within one transaction $/
    attribute scInvalidAttempts : int
    attribute extendedCustomerId : IdentityAlphaNumeric40
    attribute guid : DescriptionShort
    attribute appId : String(10)

    /$ Message dialog config: exclusive card registered $/
    attribute exclusiveCardRegisteredMessageDialogConfig : MessageDialogConfig

    /$ List of exclusive card types which are not allowed to be registered with Supercard $/
    attribute exclusiveCardTypes : String

    /$ defines if the IMPO club status icon should be shown $/
    attribute displayIconClubStatus : boolean

    /$ defines if salutation and name is displayed on POS screen $/
    attribute displayPanelCustomerName : boolean

    /$ One condition to decide, whether trustlevel webservice has to be called $/
    attribute checkTrustlevel : boolean
  }

  entity EmployeeCardRegistrationConfigDO_CST extends ProcessConfig {

  /$ Defines whether the function must be started with customer card number as input or not
      True: Customer card number is mandatory input for the function call.
      False: Customer card number is not needed for the function call. $/
    attribute customerRequired : boolean

    /$ It specifies whether the customer number can be entered manually. $/
    attribute manualInput : boolean

    /$ Determines whether a message is displayed when the customer card has been registered. $/
    attribute showRegistrationMessage : boolean

    /$ Employee number$/
    attribute employeeID : String

    /$ Specifies the validity of the customer card$/
    attribute validDayMonth : String

    /$ Determines whether the employee card can be registered when the web service is not available.$/
    attribute offlineAllowedForEmployeeCard : boolean

    /$ true: EC validation process on WS is done in background
       false: EC validation on WS is processed in foreground with waiting dialog on POS screen $/
    attribute runInBackground : boolean with default 'true'

    /$ Determines whether the discarding function is allowed $/
    attribute discardingAllowed : boolean

    /$ Customer operation configuration $/
    attribute customerOperationConfig : CustomerOperationConfigDO_EXT

    /$ Webservice configuration id. $/
    attribute adapterConfigId : String

    /$ Configuration Id of discard customer card batch process $/
    attribute discardCustomerBatchConfigId : String with default "DiscardCustomerBatchConfigs_CST.Default"

    /$ Message dialog config: function not allowed $/
    attribute functionNotAllowedMessageDialogConfig : MessageDialogConfig

    /$ Message dialog config: tender line exits $/
    attribute tenderLineExistsMessageDialogConfig : MessageDialogConfig

    /$ Message dialog config: manual entry not allowed $/
    attribute manualEntryNotAllowedMessageDialogConfig : MessageDialogConfig

    /$ Message dialog config: card already registered $/
    attribute cardAlreadyRegisteredMessageDialogConfig : MessageDialogConfig

    /$ Message dialog config: card missing $/
    attribute cardMissingMessageDialogConfig : MessageDialogConfig

    /$ Message dialog config: card registered successfully $/
    attribute cardRegisteredMessageDialogConfig : MessageDialogConfig

    /$ Message dialog config: card not valid$/
    attribute cardNotValidMessageDialogConfig : MessageDialogConfig

    /$ List of sources that came from EIQ $/
    attribute eiqSourceList       : String[0..*] indistinct

    /$ defines whether it is also allowed to register employee card manually or only via scanner $/
    attribute registrationWithManualInputAllowed : boolean

    /$ Message dialog config: exclusive card registered $/
    attribute exclusiveCardRegisteredMessageDialogConfig : MessageDialogConfig

    /$ List of exclusive card types which are not allowed to be registered with Supercard $/
    attribute exclusiveCardTypes : String

  }

  entity OtherCardRegistrationConfigDO_CST extends ProcessConfig {

    /$ Determines whether a message is displayed when the customer card has been registered. $/
    attribute showRegistrationMessage : boolean

    /$ Debitor number - only part from whole barcode (without prefix and checksum number) $/
    attribute debitorNumber : String

    /$ It specifies whether the debitor customer will be validated via debitor WS $/
    attribute validateDebitorCustomer : boolean

    /$ List of allowed debit card third party types (for example for POS's DC card type it is third party type KK )  $/
    attribute allowedWsDebitorCardTypes : String [ 0 .. * ]

    /$ List of allowed card types, which can discarded via discarding sub processes for example DC $/
    attribute discardingAllowedForCardTypes : String [ 0 .. * ]

    /$ Determines whether call validation WS in background or show waiting message $/
    attribute runInBackground : boolean

    /$ Inherited customer operation configuration as customerId, customerGroupId, customerCardType, customerCardTypeDescriptionKey etc. $/
    attribute customerOperationConfig : CustomerOperationConfigDO_EXT

    /$ Webservice configuration id for calling debitor WS $/
    attribute adapterConfigId : String

    /$ Dummy cards configuration, which contains list of debitor numbers of dummy debitor cards $/
    attribute dummyCardsConfig : OtherCardRegistrationDummyCardsConfigDO_CST

    /$ Configuration Id of discard customer card batch process $/
    attribute discardCustomerBatchConfigId : String with default "DiscardCustomerBatchConfigs_CST.Default"

    /$ Message dialog config: function not allowed $/
    attribute functionNotAllowedMessageDialogConfig : MessageDialogConfig

    /$ Message dialog config: tender line exits $/
    attribute tenderLineExistsMessageDialogConfig : MessageDialogConfig

    /$ Message dialog config: manual entry not allowed $/
    attribute manualEntryNotAllowedMessageDialogConfig : MessageDialogConfig

    /$ Message dialog config: card already registered $/
    attribute cardAlreadyRegisteredMessageDialogConfig : MessageDialogConfig

    /$ Message dialog config: card missing $/
    attribute cardMissingMessageDialogConfig : MessageDialogConfig

    /$ Message dialog config: card registered successfully $/
    attribute cardRegisteredMessageDialogConfig : MessageDialogConfig

    /$ Message dialog config: exclusive card registered $/
    attribute exclusiveCardRegisteredMessageDialogConfig : MessageDialogConfig

    /$ defines whether it is also allowed to register other card manually or only via scanner $/
    attribute registrationWithManualInputAllowed : boolean

    /$ List of exclusive card types which are not allowed to be registered with Supercard $/
    attribute exclusiveCardTypes : String

  }

  entity ExclusiveCardRegistrationConfigDO_CST extends ProcessConfig {
    /$ List of card types which are not allowed to be registered with exclusive cards $/
    required attribute forbiddenCardTypes : String

    /$ Check if the WS for exclusive card validation should be called $/
    required attribute validateExclusiveCard : boolean

    /$ true:  validation process on WS is done in background, all WarnDialogs are supressed and postponed to synchronization point
    false:  validation on WS is processed in foreground with waiting dialog on POS screen $/
    required attribute runInBackground : boolean

    /$ Defines whether it is also allowed to register exclusive card manually (e.g. using numpad) or only via scanner $/
    required attribute registrationWithManualInputAllowed : boolean

    /$ Webservice configuration id for calling debitor WS $/
    attribute adapterConfigId : String

    /$ Customer operation configuration $/
    attribute customerOperationConfig : CustomerOperationConfigDO_EXT

    /$ Message dialog config: manual entry not allowed $/
    attribute manualEntryNotAllowedMessageDialogConfig : MessageDialogConfig

    /$ Message dialog config: tender line exits $/
    attribute tenderLineExistsMessageDialogConfig : MessageDialogConfig

    /$ Message dialog config: forbidden card registered $/
    attribute forbiddenCardRegisteredMessageDialogConfig : MessageDialogConfig

    /$ Message dialog config: card missing $/
    attribute cardMissingMessageDialogConfig : MessageDialogConfig

    /$ Message dialog config: card invalid $/
    attribute cardInvalidMessageDialogConfig : MessageDialogConfig
  }

  entity DiscardCustomerBatchConfigDO_CST extends ProcessConfig {

    /$ It defines whether the function is started from customer entry funcion or manually (e.g. from cash register menu) $/
    attribute manuallTrigger : boolean with default "false"

    /$ customer group name of existing customer card in transaction, value is delivered from the calling function $/
    attribute originalCustomerGroupName : String

    /$ card ID of existing customer card in transaction, value is delivered from the calling function $/
    attribute originalCustomerCardId : String

    /$ source of existing customer card in transaction, value is delivered from the calling function $/
    attribute originalCustomerCardSource : String

    /$ defines whether the Supercard discarding(01050101992) is processed $/
    attribute discardCustomerSupercard : boolean with default "true"

    /$ defines whether the employee card discarding(01050101993) is processed $/
    attribute discardCustomerEmployeeCard : boolean with default "true"

    /$ defines whether the function  discarding for other cards(01050101994) is processed $/
    attribute discardCustomerOtherCards : boolean with default "true"

    /$ defines whether the function  discarding for exclusive cards(01050101986) is processed $/
    attribute discardCustomerExclusiveCards : boolean with default "true"

    /$ Message dialog config: function not allowed $/
    attribute functionNotAllowedMessageDialogConfig : MessageDialogConfig

    /$ Message dialog config: worning no customer registered $/
    attribute noCustomerRegisteredMessageDialogConfig : MessageDialogConfig

    /$ Message dialog config: confirmation to delete customer card $/
    attribute deleteCardMessageDialogConfig : MessageDialogConfig

    /$ Message dialog config: confirmation keep or delete customer card$/
    attribute keepOrDeleteMessageDialogConfig : MessageDialogConfig

    /$ defines whether the confirm dialog "keep_or_delete_customer_cards" is displayed $/
    attribute discardingDialogEnabled : boolean with default "true"

  }

  entity DiscardCustomerConfigDO_CST extends ProcessConfig {

    /$ Card type of the customer that should be removed from transaction $/
    attribute cardTypeToDiscardList : String [ 0 .. * ]

    /$ the parameter defines a list of sources of the customer card
         for which the function is not allowed possible values: SCANNER, SELFSCAN, TWINT, BADGE, ORIG_TRX $/
    attribute forbiddenToDiscardSourceList : String [ 0 .. * ]

    /$ Message dialog config: function not allowed $/
    attribute functionNotAllowedMessageDialogConfig : MessageDialogConfig

    /$ Message dialog config: forbiden to discard $/
    attribute forbidenToDiscardMessageDialogConfig : MessageDialogConfig

    /$ Message dialog config: forbiden card source to discard $/
    attribute forbidenCardSourceToDiscardMessageDialogConfig : MessageDialogConfig

    attribute positionOperationConfig : PositionOperationConfig
  }

  entity SupercardSynchronizationConfigDO_CST extends ProcessConfig {

    /$ Maximum wait time in seconds for asynchronous supercard registration result $/
    required attribute synchronizationTimeout : int
  }

  master entity EmployeeCardSynchronizationConfigDO_CST extends ProcessConfig {

    /$ Maximum wait time in seconds for asynchronous employee card registration result $/
    required attribute synchronizationTimeout : int

  }

  entity DebitorCardSynchronizationConfigDO_CST extends ProcessConfig {

    /$ Maximum waiting time for result of asynchronous call "GetCreditInfo" in seconds   $/
    required attribute synchronizationTimeout : int
  }
  
  entity GetWholesaleCouponSynchronisationConfigDO_CST extends ProcessConfig {
    required attribute synchronizationTimeout : int
    required attribute retryTimeout : int
    required attribute displayGetCouponError : boolean
  }

  entity ExclusiveCardSynchronizationConfigDO_CST extends ProcessConfig {

    /$ Maximum waiting time for result of asynchronous call "GetExclusiveCard" in seconds   $/
    required attribute synchronizationTimeout : int
  }

  entity OtherCardRegistrationDummyCardsConfigDO_CST extends AbstractEntity {
    required attribute otherCardRegistrationDummyCardsConfigs : OtherCardRegistrationDummyCardDO_CST [ 0 .. * ]

  }

  entity OtherCardRegistrationDummyCardDO_CST {
    required attribute fieldId : String
    required attribute cardNr : String
    required attribute name : String
    required attribute sellingRegion : String
  }
}
