dslLevel 2

Package com.gk_software.cst.pos.client.model.config.do_types.pos_process


Import com.gk_software.cst.pos.client.model.config.do_types.pos_process.CustomerRegistrationConfig_EXT.CustomerOperationConfigDO_EXT
Import com.gk_software.pos.api.model.config.do_types.processes.flows.ProcessConfig_DO.ProcessConfig
Import com.gk_software.pos.api.model.config.do_types.processes.ui.DialogConfig_DO.MessageDialogConfig

domain object CustomerRegistrationConfig_CST {
  version "v00.00.01"

  master entity CustomerRegistrationConfigDO_CST extends ProcessConfig {

    /$ It specifies whether the value is available on the entry line, or having been entered before the button press, is used as the customer number or ignored.
      True: The value available on the entry line is used.
      False: The value available on the entry line is ignored $/
    attribute takeInputFieldValue : boolean

    /$ It specifies whether the customer number can be entered manually. $/
    attribute manualInput : boolean

    /$ Required address type. SC - SuperCard $/
    attribute forcedCustomerCardType : String

    /$ Determines whether a message is displayed when the customer card has been registered. $/
    attribute showRegistrationMessage : boolean

    /$ Employee number$/
    attribute employeeID : String

    /$ Partner ID for webservice request$/
    attribute partnerID : String

    /$ Default customer number, global parameter$/
    attribute defaultCustomerId : String

    /$ Default customer group, global parameter$/
    attribute defaultCustomerGroup : String

    /$ Defines if a query is performed on the bonus point system$/
    attribute bpsUsage : boolean

    /$ Determines whether the employee customer card is checked against the employee management system $/
    attribute checkEmployee : boolean

    /$ Specifies the validity of the customer card$/
    attribute validYear : int ( 99 )

    /$ Determines whether the employee card can be registered when the web service is not available.$/
    attribute offlineAllowedForEmployeeCard : boolean

    /$ Defines the dialog for the Supercard registration
       00 … ScanExpect Supercard
       01 … FieldLabel Supercard $/
    attribute supercardRegistrationView : String

    /$ Debtor number (Part of the customer number at credit customers) $/
    attribute debitorNumber : String

    /$ List of allowed card types (separated by semicolons)$/
    attribute allowedCreditCardType : String

    /$ List of customer groups (separated by semicolons) that are not allowed for the manual entry $/
    attribute customerGroupWithoutManualInput : String

    /$ Defines whether the debtor query is performed $/
    attribute debitWsUsage : boolean

    /$ Timeout in milliseconds (check bonus point system) $/
    attribute checkBpsTimeout : int

    /$ Informs whether the function for Twint was called. (internal parameter, usage only for scan processor rules) $/
    attribute isTwint : boolean

    /$ Credit customer web adapter configuration $/
    attribute creditCustomerAdapterConfig : String

    /$ Bonus points web adapter configuration $/
    attribute bonusPointsAdapterConfig : String

    /$ Customer operation configuration $/
    attribute customerOperationConfig : CustomerOperationConfigDO_EXT

    /$ Customer assigned message dialog configuration $/
    attribute customerAssignedInfoDialog  : MessageDialogConfig

    /$ Dummy cards list $/
    attribute dummyCards :  CustomerDummyCardDO_CST[0..*]

    /$ value "Kanal" for WS request $/
    attribute channel : String

  }


  entity CustomerDummyCardDO_CST {

    attribute sellingRegion : String

    attribute name : String

    attribute cardNr : String
  }

}
