dslLevel 2
Package com.gk_software.cst.pos.client.model.config.do_types.pos_process
Import com.gk_software.pos.api.model.config.do_types.processes.actions.CustomerOperationConfig_DO.CustomerOperationConfig


Import com.gk_software.pos.api.model.config.do_types.processes.flows.customer.CustomerRegistrationConfig_DO.CustomerRegistrationConfig
Import com.gk_software.cst.pos.client.model.config.do_types.pos_process.EnterCouponConfig_EXT.EnterCouponConfigDO_EXT
Import com.gk_software.pos.api.model.config.do_types.processes.flows.auth.AuthorizationConfig_DO.AuthorizationConfig

domain object CustomerRegistrationConfig_EXT {
  version "1.0"
  master entity CustomerRegistrationConfigDO_EXT extends CustomerRegistrationConfig {

    /* prefix of offline cards */
    attribute offlineCardPrefix : String

    /* Maximum timeout of call to loyalty webservice */
    attribute accountCouponTimeout : long

    /* controls if timeout of call to loyalty webservice is taken from parameter accountCouponTimeout */
    attribute forcedAccountCouponWait : boolean

    /* country code for the UID to be checked (CC) */
    attribute uidCountryValue : String

    /* userID for webservice calls */
    attribute userID : String

    /* Determines whether the webservice "CHECK_DEBITOR_2" is called in the background */
    attribute backgroundCall : boolean
    /* instance name of webService config for CHECK_DEBITOR_2 WS */
    required attribute creditCustomerAdapterConfig : String

    /* instance name of webService config for UID_CHECK WS */
    required attribute uidCheckAdapterConfig : String
    
    /* Get wholesale coupon web adapter configuration */
    attribute getWholesaleCouponAdapterConfig : String
    
    attribute customerOperationConfig_EXT : CustomerOperationConfigDO_EXT
    
    /$ It specifies whether is the Wholesale Customer. $/
    attribute wholesaleCustomerRequired : boolean
    
    attribute wholesaleEnterCouponConfig : EnterCouponConfigDO_EXT
    
    /$ Determines, whether a business customer can get a private receipt/bon $/
    attribute selectReceiptType : boolean
    
    /$ Determines, whether suspended receipts are checked for a private receipt $/
    attribute checkSuspendedReceiptsPrivateCustomer : boolean
    
    /$ Determines, whether the transaction is cancelled when a customer is already registered and an unknown customer (card) is registered $/
    attribute cancelTransactionWhenCustomerUnknown : boolean
    
    /$ Determines, whether independent of the type of the receipt or customer always gross prices are shown. This will influence the customer display and the bon preview only $/
    attribute alwaysDisplayGrossPrices : boolean
  }

  /$ Extended configuration for general customer operations. $/
  entity CustomerOperationConfigDO_EXT extends CustomerOperationConfig {

     /$ Registration source of the customer card ("SCANNER", "TWINT", "BADGE", "ORIG_TRX") $/
     attribute customerCardSource : String with default "SCANNER"
     /$ Default customer group, global parameter$/
     attribute defaultCustomerGroup : String
     /$ if need to remove Default Customer by defaultCustomerGroup $/
     attribute needToRemoveDefaultCustomer : boolean
     /$ if we are using TG channel - we should search customers in DB $/
     attribute searchDatabase : boolean
  }
}
