dslLevel 2

Package com.gk_software.cst.pos.client.model.config.do_types.pos_process


Import com.gk_software.pos.api.model.config.do_types.processes.ui.DialogConfig_DO.PromptUserDialogConfig
Import com.gk_software.pos.api.model.config.do_types.processes.actions.PositionOperationConfig_DO.PositionOperationConfig
Import com.gk_software.pos.api.model.config.do_types.processes.actions.CustomerOperationConfig_DO.CustomerOperationConfig
Import com.gk_software.pos.api.model.config.do_types.processes.flows.ProcessConfig_DO.ProcessConfig
Import com.gk_software.pos.api.model.config.do_types.processes.ui.DialogConfig_DO.MessageDialogConfig

domain object EProductConfig_CST {
  version "v00.00.01"

  master entity EProductVoucherSaleConfigDO_CST extends ProcessConfig {

    /$link to the position operation configuration for Voucher sale $/
    attribute positionOperationConfig : PositionOperationConfig

    /$ Maximal number of characters per line of voucher printout $/
    attribute charsPerLine : int

    /$ E-product web adapter configuration $/
    attribute webAdapterConfig : String

    /$ prompt user configuration $/
    required attribute promptUserConfig : PromptUserDialogConfig

    /$ Defines whether identification mask is shown after security dialog $/
    attribute showIdentMask : boolean

    /$ Defines limit for displaying of security dialog $/
    attribute limitSecurityQuestion : int
  }

  entity EProductVoucherProcessingConfigDO_CST extends ProcessConfig {

    /$ E-product web adapter configuration $/
    attribute webAdapterConfig : String
  }

  entity EProductVoucherVoidingConfigDO_CST extends ProcessConfig {

    /$ E-product web adapter configuration $/
    attribute webAdapterConfig : String
  }

  entity EProductVoucherReturnConfigDO_CST extends ProcessConfig {

    /$ E-product web adapter configuration $/
    attribute webAdapterConfig : String

    /$ Voucher barcode number $/
    attribute voucherBarcode : String

    /$link to the position operation configuration for Voucher sale $/
    attribute positionOperationConfig : PositionOperationConfig

  }

  entity POSARegistrationConfigDO_CST extends ProcessConfig {

    /$link to the position operation configuration for POSA sale $/
    attribute positionOperationConfig : PositionOperationConfig

    /$ POSA card number $/
    attribute posaCardNumber : String

    /$ Defines type of reason that will be saved in line item extension $/
    attribute reasonType : String

    /$ E-product web adapter configuration $/
    attribute webAdapterConfig : String

    /$ Defines whether identification mask is shown after security dialog $/
    attribute showIdentMask : boolean

    /$ Defines limit for displaying of security dialog $/
    attribute limitSecurityQuestion : int

    /$ Defines index from which number will be masked with * $/
    attribute maskingBeginIndex : int

    /$ Defines index to which number will be masked with * $/
    attribute maskingEndIndex : int

  }

  entity POSAActivationConfigDO_CST extends ProcessConfig {

    /$ Number of characters per line on the receipt. $/
    attribute charsPerLine : int

    /$ E-product web adapter configuration $/
    attribute webAdapterConfig : String
  }

  entity POSAVoidingConfigDO_CST extends ProcessConfig {

    /$ E-product web adapter configuration $/
    attribute webAdapterConfig : String
  }

  entity POSAReturnConfigDO_CST extends ProcessConfig {

    /$link to the position operation configuration for POSA sale $/
    attribute positionOperationConfig : PositionOperationConfig

    /$ E-product web adapter configuration $/
    attribute webAdapterConfig : String
  }

  entity EProductSecurityDialogConfigDO_CST extends ProcessConfig {

    /$ Defines limit for displaying of security dialog $/
    attribute limitSecurityQuestion : int

    /$ Defines whether identification mask is shown after security dialog $/
    attribute showIdentMask : boolean

    attribute hintDialog : MessageDialogConfig

    attribute posaRegistrationConfig : POSARegistrationConfigDO_CST
  }
}
