dslLevel 2

Package com.gk_software.cst.pos.client.model.config.do_types.pos_process

Import com.gk_software.pos.api.model.app.Flag
Import com.gk_software.pos.api.model.config.do_types.processes.flows.registration.EnterCouponConfig_DO.EnterCouponConfig
Import com.gk_software.cst.pos.client.model.config.do_types.pos_process.CustomerIdentificationConfig_EXT.CustomerIdentificationConfigDO_EXT

domain object EnterCouponConfig_EXT {
	version "1.0"
	master entity EnterCouponConfigDO_EXT extends EnterCouponConfig {
	 /$ minimum condition value $/
	 attribute minPrivilegeValue : double
	 /$ maximum condition value $/
	 attribute maxPrivilegeValue : double
	 /$ Determines whether RetailTransactionCouponSummaryDO_CST.reference must be filled with the text from the corresponding promotion $/
	 attribute referenceFillingRequired : Flag
	 /$ determines whether an error message is displayed for invalid coupons $/
	 attribute checkCouponData : Flag
	 /$  registration type of the coupon
       00 (registered directly)
       01 (registered by the customer card) 
   $/
	 attribute registrationSource : String
	 /$  list of prefixes, that are not checked for the existence of a corresponding promotion
   (these are not in master data => they do not have RetailTransactionCouponSummaryDO_CST.reference, separated by semicolons)  $/
	 attribute notCheckedCouponPrefixes : String
	 /$ Determines whether the registered promotion coupon is a "customer individual coupon" $/
   attribute individualCoupon : Flag
   /$ Determines whether the customer individual coupon registration can continue, if web service is offline $/
   attribute offlineRegistration : Flag
   /$ Determines whether RetailTransactionCouponSummary.InputCount and subsequent columns
      (RetailTransactionCouponSummaryDO_CST.ManualCouponQuantity and
      RetailTransactionCouponSummaryDO_CST.DigitalCouponQuantity) should be set according to
      the rules of ROP promotion coupons.

      (TG functionality) 
   $/
   attribute subsequentRegistration : Flag
   /$ List of coupon numbers $/
   attribute couponNumberList : String [0..*]
   /$ Determines whether view coupon_registration should be shown in each case $/
   attribute forceView : Flag
   /$ input of pos function $/
   attribute input : String
   /$ whole input barcode string of pos function $/
   attribute registrationNumber : String
   /$ Determines whether couponNumber should be validated according instantWinCouponPrefix 
      (instant win coupon must not be registered, if skipForbiddenCouponCheck == false)
   $/
   attribute skipForbiddenCouponCheck : Flag
   /$ Determines whether coupon is registered via customer scanner (for example KCH scanner) $/
   attribute registeredByCustomerScanner : Flag
   /$ the individual coupon winning code, which is used for calling external gluecks code interface $/
   attribute winningCode : String
   /$ Determines whether individual coupon supercard number from web service $/
   attribute supercardNumberFromWinningCodeInfos : String
   /$ Flag is set to TRUE, if calling of individual coupon web service was offline $/
   attribute individualCouponOffline : Flag
   /$ promotion reference, which was found between coupon and promotion in master data $/
   attribute couponReference : String
   /$ GluecksCode web service configuration $/
   attribute webServiceConfig : String
   /$ It defines if and how a customer gets identified. $/
   attribute customerIdentificationConfigEXT : CustomerIdentificationConfigDO_EXT
   /$ Is coupon barcode going to be scanned $/
   attribute isBarcodeScanExpected : boolean
	}
}
