dslLevel 1

Package com.gk_software.cst.pos.client.model.config.do_types.pos_process

Import com.gk_software.pos.api.model.config.do_types.processes.flows.giftCertificate.GiftCertificatePaymentConfig_DO.GiftCertificatePaymentConfig
Import com.gk_software.cst.pos.client.model.config.do_types.pos_process.GiftCertificateCardTypeMappingConfig_CST.GiftCertificateCardTypeMappingConfigDO_CST
Import com.gk_software.cst.pos.client.model.config.do_types.pos_process.PaymentOperationConfig_EXT.GiftCertificatePaymentOperationConfigDO_EXT

domain object GiftCertificatePaymentConfig_EXT {
    version "1.0"

    /$ Config for gift certificate payment process $/
    master entity GiftCertificatePaymentConfigDO_EXT extends GiftCertificatePaymentConfig {

        /$ GUTSCH_BETRAG $/
        attribute maxPayableAmount : double

        /$ Prompt for amount to pay input or not $/
        attribute promptForAmount : boolean

        /$ Child protection verification switch $/
        attribute childProtectionEnabled : boolean

        /$ Drawer open verification switch $/
        attribute drawerOpenEnabled : boolean

        /$ Gift Card Number $/
        attribute gcNumber : String

        /$ Gift Certificate Type $/
        attribute gcType : String

        /$ Tender class code $/
        attribute tenderClassCode : String

        /$ Blacklisted item ids $/
        attribute blacklist : String[0 .. *]

        /$ Forbidden items for child protection $/
        attribute forbiddenItems : String

        /$ Forbidden item groups for child protection $/
        attribute forbiddenItemGroups : String

        /$ allow buying GC via child protected GC  $/
        attribute allowChildProtectedGcPurchase : boolean

        /$ Gift certificate web service configuration $/
        required attribute giftCertificateAdapterConfig : String

        /$ Allows to input amount as multiple of 5 only (i.e. 5.00/10.00/15.00 etc) $/
        attribute inputAmountMultiple5 : boolean

        /$ Gift certificate to tender mapping configuration $/
        required attribute tenderConfig : GiftCertificateCardTypeMappingConfigDO_CST        

        /$ The payment operation config for the gift certificate payment action ext $/
        required attribute paymentOperationConfig_EXT : GiftCertificatePaymentOperationConfigDO_EXT
    }
}