dslLevel 2

Package com.gk_software.cst.pos.client.model.config.do_types.pos_process
Import com.gk_software.cst.pos.client.model.config.do_types.global.TobaccoTrackingConfig_CST.TobaccoTrackingConfigDO_CST

Import com.gk_software.cst.pos.client.model.config.do_types.global.MedicineStoreConfig_CST.MedicineStoreConfigDO_CST

Import common.QuantityCount

Import common.Identity
Import common.ItemID
Import com.gk_software.cst.pos.client.model.config.do_types.pos_process.LinkedItemConfig_CST.LinkedItemConfigDO_CST
Import com.gk_software.cst.pos.client.model.config.do_types.pos_process.RegisterEcoCleanLineItemConfig_CST.RegisterEcoCleanLineItemConfigDO_CST
Import com.gk_software.pos.api.service.transaction.LineItemServiceObjects_DO.QuantityInput
Import com.gk_software.pos.api.model.config.do_types.processes.flows.registration.ItemEntryConfig_DO.ItemEntryConfig
Import com.gk_software.pos.api.model.config.do_types.processes.flows.ProcessConfig_DO.ProcessConfig
Import com.gk_software.pos.api.model.app.Code4
Import com.gk_software.cst.pos.client.model.config.do_types.pos_process.ItemRegistrationConfig_EXT.ItemRegistrationConfigDO_EXT
Import com.gk_software.pos.api.model.config.do_types.processes.ui.DialogConfig_DO.PromptUserDialogConfig
Import com.gk_software.cst.pos.client.model.config.do_types.pos_process.QuantityLockLimitConfig_CST.QuantityLockLimitConfigDO_CST
Import com.gk_software.cst.pos.client.model.config.do_types.pos_process.PromotionOperationAdditionalConfig_CST.PromotionOperationAdditionalConfigDO_CST
Import com.gk_software.pos.api.model.config.do_types.processes.ui.TableConfig_DO.TableConfig

domain object ItemEntryConfig_EXT {
  version "1.0"

  master entity ItemEntryConfigDO_EXT extends ItemEntryConfig {
    /$ Reasons $/
    attribute reasonCodeGroupCodes  : String [ 0 .. * ]

    /$predefined amount$/
    attribute predefinedAmount : String

    /$ It references the item details config to determine if additional info is needed $/
    attribute itemRegistrationConfig_EXT : ItemRegistrationConfigDO_EXT

    /$ Registration area of POS $/
    attribute posRegistrationArea : String

    attribute checkStock : boolean

    attribute quantityLockLimitConfig : QuantityLockLimitConfigDO_CST

    /$ Defines whether the item should be searched online (webservice) if the item is not available in the local database $/
    attribute searchForItemOnline : boolean

    /$ List of merchandise categories $/
    attribute dummyItemGroups : String [0 .. *] indistinct

    attribute labelingQualityMonitoringItemEANLength : int

    /$ If it's true, additional query for new article description is showed $/
    attribute askForArticleText : boolean

    /$ Controls whether the EAN is always taken over or only if the query for the unknown item was successful $/
    attribute takeOverEan : boolean

    required attribute promptForArticleTextConfig : PromptUserDialogConfig

    required attribute promptForPriceConfig : PromptUserDialogConfig

    attribute itemRegisteredManuallyCode : String

    attribute promotionTriggerAcousticSignalConfigId : String

    attribute getItemDataWebServiceAdapterConfig : String

    attribute zeroPriceAllowed : boolean

    attribute itemInfoUserId : String

    attribute multipackLimitQuantity : QuantityCount
    attribute multipackPiecesQuantity : QuantityCount
    attribute multipackWholePacksQuantity : QuantityCount
    attribute multipackDepositItemQuantity : QuantityCount
    attribute multipackDepositItemID : ItemID

    attribute complaintManualPriceRequired : boolean

    attribute freeItem : boolean

    attribute registerEcoCleanLineItemConfig : RegisterEcoCleanLineItemConfigDO_CST

    /$ Additional project specific promotion operation configuration $/
    required attribute promotionOperationAdditionalConfig : PromotionOperationAdditionalConfigDO_CST

    /$ Manual line item discount configuration id for special sale $/
    required attribute manualLineItemDiscountSpecialSaleNewPriceConfigId : String

    /$ Manual line item discount configuration id for special sale $/
    required attribute manualLineItemDiscountSpecialSaleRebatePercentConfigId : String

    /$ Manual line item discount configuration id for special sale $/
    required attribute manualLineItemDiscountSpecialSaleRebateAmountConfigId : String

    /$ Manual line item discount configuration id for special sale $/
    required attribute manualLineItemDiscountPriceEntryRequiredConfigId : String

    /$ Additional project parameters for linked items (warranty) $/
    attribute linkedItemConfig : LinkedItemConfigDO_CST

    /$ ItemNr of the WarrantyPlusItem
          Default : 9901337 $/
    attribute warrantyPlusItem : String

    /$ packageCount value from response of StockCheck WS $/
    attribute packageCount : String
    /$ stockGround value from response of StockCheck WS $/
    attribute stockGround : String
    /$ availableQuantity value from response of StockCheck WS $/
    attribute availableQuantity : String
    /$ flag which define if need to set relative Stock info (SaleReturnLineItemExtensions) for item $/
    attribute needSetStockCheckMarks : boolean
    /$ flag which define if need to reset/remove relative Stock info (SaleReturnLineItemExtensions) for item $/
    attribute needResetStockCheckMarks : boolean
    /$ Defines the MerchandiseGroupIDs of tobacco items $/
    attribute tobaccoMHGIDs  : String [ 0 .. * ]

    /$ The item number/ EAN of a prepared dummy item which can be filled with values from the webservice response in case of missing item in local data base. $/
    required attribute dummyItemNrEan : String
    /$ Medicine store configuration $/
    attribute medicineStoreConfig : MedicineStoreConfigDO_CST

  attribute showWaitingDialog : boolean

    attribute dynamicTableauItemPriceList : String
    attribute dynamicTableauItemPrice : String
    attribute dynamicTableauText1 : String

    /$ final total price of scale line item include scale action price modifier (but without Liquitation from scale barcode) $/
    attribute positionAmountScaleTotal:double
    
    /$  SCALE_ACTION_PRICE_PREPACKED_ITEM_REGISTRATION_MODE as mode3 note: Registration of prepacked weight item with action price (price type 03)
        SCALE_NORMAL_PRICE_PREPACKED_ITEM_REGISTRATION_MODE as mode4 note: Registration of prepacked weight item with normal price (price type 00)
        SCALE_ACTION_PRICE_ITEM_REGISTRATION_MODE as mode31 note: Registration of scale items (use RegArea+PLU)  with action price (pricetype 03)
        SCALE_NORMAL_PRICE_ITEM_REGISTRATION_MODE as mode41 note: Registration of scale items (use RegArea+PLU) with normal price (price type 00)
        DATAMATRIX_ACTION_PRICE_PREPACKED_ITEM_REGISTRATION_MODE note: Registration of a prepacked weight item from the datamatrix code with action price (price type 03)
        DATAMATRIX_NORMAL_PRICE_PREPACKED_ITEM_REGISTRATION_MODE note: Registration of a prepacked weight item from the datamatrix code with normal price (price type 00)
        NO_SCALE_MODE as default note: Standard item entry (default)
     $/
    attribute scaleRegistrationMode : String
    
    /$ Determines whether the transaction should be checked for items from a different scale domain $/
    attribute scaleDomainCheck : boolean
    /$ Order number from an external system (from barcode) $/
    attribute referenceNumber : String
    
    attribute finalPositionQuantity : double
    attribute woodItemRegistration : boolean
    attribute woodItemReturnReason : String
    
    /$ Parameter determines whether the best before date as String in format for example:    $/
    attribute bestBeforeDateAsString : String
    
    /$ Parameter determines whether the best expiry date as String in format for example:    $/
    attribute expiryDateAsString : String
    
    /$ Parameter determines whether best before check should be skipped. $/  
    attribute checkBestBeforeDate: boolean
              
    /$ Parameter determines whether batch lot. $/  
    attribute batchLot : String
    
    /$ Parameter determines origin (ISO country code ) $/
    attribute origin : String

    /$ Parameter determines item weight. For example from scale datamatrix barocde. $/
    attribute itemWeight : double
    
    attribute returnEProductVoucherFlag : boolean
    
    attribute returnTopupVoucherFlag : boolean
    
    /$ This is filled with the whole tobacco tracking code if a tobacco tracking code was scanned $/
    attribute tobaccoTrackingCode : String
    
    /$ This is filled with the tobacco Tracking Code from the scanned DataMatrix $/
    attribute tobaccoSerialNumber : String
    
    /$ It defines, if the POS is in mode for registering an tobacco article with the TobaccoTrackingFlag $/
    attribute tobaccoRegistrationMode : boolean
    
    attribute tobaccoTrackingConfig : TobaccoTrackingConfigDO_CST
    
    required attribute promptTobaccoCodeRegisterGtinConfig : PromptUserDialogConfig
    
    attribute showItemNotFoundWarning : boolean
    
    attribute quantityPredefinedForPluPieceItems : int
    
    /$ This parameter holds the limit for the maximum count of (non voided) sale line items $/
    attribute itemCountLimit : int
    
    /$ Defines if the country of origin is being checked in DB, selected automatically or selected via a screen $/
    attribute printCountryOfOrigin : boolean
    
    required attribute countryOfOriginTableConfig : TableConfig
  }

}

    typedef ScaleRegistrationModeType_CST : enum with type String [
    SCALE_ACTION_PRICE_PREPACKED_ITEM_REGISTRATION_MODE as "SCALE_ACTION_PRICE_PREPACKED_ITEM_REGISTRATION_MODE",
    SCALE_NORMAL_PRICE_PREPACKED_ITEM_REGISTRATION_MODE as "SCALE_NORMAL_PRICE_PREPACKED_ITEM_REGISTRATION_MODE",
    SCALE_ACTION_PRICE_ITEM_REGISTRATION_MODE as "SCALE_ACTION_PRICE_ITEM_REGISTRATION_MODE",
    SCALE_NORMAL_PRICE_ITEM_REGISTRATION_MODE as "SCALE_NORMAL_PRICE_ITEM_REGISTRATION_MODE",
    DATAMATRIX_ACTION_PRICE_PREPACKED_ITEM_REGISTRATION_MODE as "DATAMATRIX_ACTION_PRICE_PREPACKED_ITEM_REGISTRATION_MODE",
    DATAMATRIX_NORMAL_PRICE_PREPACKED_ITEM_REGISTRATION_MODE as "DATAMATRIX_NORMAL_PRICE_PREPACKED_ITEM_REGISTRATION_MODE",
    NO_SCALE_BARCODE_MODE as "NO_SCALE_BARCODE_MODE"
]
