dslLevel 2
Package com.gk_software.cst.pos.client.model.config.do_types.pos_process

Import com.gk_software.pos.api.model.config.do_types.processes.flows.ProcessConfig_DO.ProcessConfig

  /$ This type defines the modes of registration linked items. $/
  typedef LinkedMode_CST : enum with type String
  [
      DEPOSIT                  as "0",
      WARRANTY                 as "1",
      MULTIPACK                as "2"
  ] 

domain object LinkedItemConfig_CST {
	version "1.0"

	master  entity LinkedItemConfigDO_CST extends ProcessConfig {
     /$ ItemNr of the linked warranty or multipack item handed over by item entry function $/
     attribute linkedItemNr : String 

     /$ Quantity of the multipack item handed over by item entry function $/
     attribute quantityLinkedItem : int
     
     /$ Defines the mode of the function that has to be used to register follow-on items:     
            0 - Deposit items
            1 - Warranty items
            2 - Multipack deposit items

            Default : 0
     $/
     attribute linkedMode : LinkedMode_CST
     
     /$ Reason for warranty items- corresponds to Reason.ReasonCode $/
     attribute warrantyReasonCode : String
     
     /$ ReasonCodeGroupCode for warranty items- corresponds to Reason.ReasonCodeGroupCode $/
     attribute warrantyReasonCodeGroupCode : String
  }
}
