dslLevel 2

Package com.gk_software.cst.pos.client.model.config.do_types.pos_process

Import com.gk_software.pos.api.model.config.do_types.processes.flows.ProcessConfig_DO.ProcessConfig
Import com.gk_software.pos.api.model.app.Code4
Import common.ReasonCode

domain object PayInOutItemEntryConfig_CST {
    version "1.0"

    /$ Configuration for pay in / pay out processes $/
    master entity PayInOutItemEntryConfigDO_CST  extends ProcessConfig {

        /$ The type allows assigning a number of reasons to the function. The parameter must have a value. $/
        required attribute reasonPayInItemCodeGroupCode : Code4

        /$ The type allows assigning a number of reasons to the function. The parameter must have a value. $/
        required attribute reasonPayOutItemCodeGroupCode : Code4

        /$ PayInOutType $/
        attribute type : PayInOutItemType

        /$ Reason for pay-in/pay-out $/
        attribute reasonCode : ReasonCode

        /$ taxGroupID $/
        attribute taxGroupID : String

        /$ Determines whether the AoE/AoA has to be the only line item in the transaction $/
        required attribute singlePosition : boolean with default "false"

        //internal parameters
        /$  0 - Standard item entry
            1 - Set component entry
            2 - Bulk Registration

            Default : 0
        $/
        attribute mode:int

    }

    typedef PayInOutItemType : enum with type String [
        PAY_IN_LINEITEM as "PAY_IN_LINEITEM",
        PAY_OUT_LINEITEM as "PAY_OUT_LINEITEM"
    ]

}