dslLevel 2

Package com.gk_software.cst.pos.client.model.config.do_types.pos_process

Import com.gk_software.cst.pos.client.model.config.do_types.pos_process.GenerateInvoiceNumberConfig_CST.GenerateInvoiceNumberConfigDO_CST
Import com.gk_software.pos.api.model.config.do_types.processes.flows.payment.PaymentEndConfig_DO.PaymentEndConfig
Import com.gk_software.pos.api.model.config.do_types.processes.ui.DialogConfig_DO.MessageDialogConfig
Import com.gk_software.cst.pos.client.model.config.do_types.pos_process.CustomerRegistrationConfig_EXT.CustomerOperationConfigDO_EXT
Import com.gk_software.cst.pos.client.model.config.do_types.pos_process.ScgcTransferConfig_CST.ScgcTransferConfigDO_CST


domain object PaymentEndConfig_EXT {
  version "v00.00.01"

  master entity PaymentEndConfigDO_EXT extends PaymentEndConfig {

    /$ Determines whether the function settle op rest is called $/
    attribute callOpRest : boolean

    /$ Defines the TenderTypeCode which leads to $/
    attribute deliveryNoteTenderTypeCode : String

    attribute skipLoyaltyReward : boolean

    /$ Determines whether the function of certificate printout is on $/
    attribute printCertificates : boolean with default "true"

    /$ TRUE – at receipt completion, a picking voucher is printed
       FALSE – a picking voucher is not printed $/
    attribute printPickingVoucher : boolean

    /$ Path to the printer, with which the picking voucher should be printed $/
    attribute pickingVoucherPrinter : String

    /$ list of tender type codes - Amount of these payments will reduce the value added tax. On tx level. $/
    attribute vatReducingTenders : String [ 0 .. * ]

    /$ Determines whether the partner role function is called. $/
    attribute partnerRoleCheck : boolean

    /$ The tax group ID for zero % group used for reduction on tx level $/
    attribute vatReducingTaxGroupID : String

    /$ MessageDialogConfig $/
    attribute viewCollectionPromotionDialog : MessageDialogConfig

    /$ Define, if the screen View receipt_end_printing_options is displayed for the transactions with suppressed sales receipt $/
    attribute printOnDemandForSuppressedSalesReceiptSco : boolean

    /$ TenderTypeCodes for which the tender amount should be subtracted weighted from the tax on position level after potential reduction by the Supercash share $/
    attribute positionVatReducingTenders : String  [ 0 .. * ] indistinct

    /$ Tender for which the tax on transaction level is reduced, but should not reduce the tax on position level and for which the rounding diff. for tax on position level is not balanced $/
    attribute notPositionVatReducingTenders : String  [ 0 .. * ] indistinct

    /$ TaxGroupID for which the addition tax entry is written on position level, in case the tax amount is reduced $/
    attribute positionVatReducingTaxGroupID : String

    /$ Tax amount decimal places count on position level$/
    attribute positionTaxAmountDecimalPlacesCount : int

    /$ Default amount decimal places count on position level $/
    attribute defaultAmountDecimalPlacesCount : int

    /$ СustomerOperationConfig_EXT $/
    attribute customerOperationConfig_EXT : CustomerOperationConfigDO_EXT

    attribute skipAllPrintouts : boolean with default "false"
    
    /$ if transaction total >= splitPaymentAmount and extensions COP_SPLIT_PAYMENT_ITEM, COP_PRIVATE_RECEIPT exist, then COP_SPLIT_PAYMENT_TRANSACTION extension is created $/
    attribute splitPaymentAmount : double
    
    /$ Reference to GenerateInvoiceNumberConfig $/
    attribute generateInvoiceNumberConfig : GenerateInvoiceNumberConfigDO_CST
    
    /$ reference of config scgc transfer with complete configurations attributes for scgc checks$/
    attribute scgcTransferConfigDO_CST:  ScgcTransferConfigDO_CST
    
   /$ id  of config scgc transfer for call automic scgc transfer from payment end $/
    attribute automaticScgcTransferConfigId : String
    
    /$ id  of config scgc transfer for call confirm transfer points scgc transfer from sco payment end $/
    attribute confirmTransferPointsScgcTransferConfigScoId : String
  }

}
