dslLevel 2

Package com.gk_software.cst.pos.client.model.config.do_types.pos_process

Import com.gk_software.cst.pos.client.model.config.do_types.pos_process.ItemEntryConfig_EXT.ItemEntryConfigDO_EXT
Import com.gk_software.pos.api.model.config.do_types.processes.actions.PositionOperationConfig_DO.PositionOperationConfig
Import com.gk_software.pos.api.model.config.do_types.processes.flows.transaction.RetrieveTransactionsConfig_DO.RetrieveTransactionsConfig
Import com.gk_software.pos.api.model.app.AbstractEntity_DO.AbstractEntity

/$ Domain objects for the retrieve transactions process $/
domain object RetrieveTransactionsConfig_EXT {
    version "v00.00.01"
    master entity RetrieveTransactionsConfigDO_EXT extends RetrieveTransactionsConfig{
        /$ allows to show a query for age after the receipt has been retrieved. If no age is entered, the restricted item cannot be sold (automatically removed in subtotal) $/
        required attribute queryAgeAfterRetrieving : boolean

        /$ CONFIG: Position operation config for line item operations and filtering transaction results. $/
        required attribute positionOperationConfig : PositionOperationConfig

        /$ Defines the ReasonCode that should be used, if Supended Transaction has to be cancelled, because it only contains AgeRestricted positions, for which were not "unlocked" $/
        required attribute ageRestrictedReasonCode : String

        /$ The type allows assigning a number of reasons to the function. The parameter must have a value. $/
        required attribute ageRestrictedReasonCodeGroup : String


    required attribute entrySupercardDuringRetrieving : boolean

    required attribute entryEmployeeCardDuringRetrieving : boolean

    required attribute entryOtherCardsDuringRetrieving : boolean

    required attribute entryExclusiveCardsDuringRetrieving : boolean

    required attribute entryWholesaleCustomerCardDuringRetrieving : boolean

    required attribute supercardRegistrationConfigId : String

    required attribute employeeCardRegistrationConfigId : String

    required attribute otherCardRegistrationConfigId : String
    
    required attribute wholesaleCustomerCardRegistrationConfigId : String

    required attribute openTransactionAllowed : boolean

    attribute fetchSscTx : boolean with default "false"
    
    required attribute itemEntryConfig : ItemEntryConfigDO_EXT

    }

  entity RetrievedCustomerToRegisterDO_CST extends AbstractEntity {
      attribute customerId : String
      attribute customerType : String
      attribute customerCardSource : String
    }

}