dslLevel 2

Package com.gk_software.cst.pos.client.model.config.do_types.pos_process

Import com.gk_software.pos.api.model.config.do_types.processes.flows.returns.ReturnWithTransactionConfig_DO.ReturnWithTransactionConfig
Import com.gk_software.pos.api.model.config.do_types.processes.flows.promotion.ManualLineItemDiscountConfig_DO.ManualLineItemDiscountConfig

domain object ReturnWithTransactionConfig_EXT {
    version "1.0"

   master entity ReturnWithTransactionConfigDO_EXT extends ReturnWithTransactionConfig {
    /$ Defines if the total rebate can be edited $/
    attribute editRebateTotal  : boolean

    attribute testEnum  : TestEnum

    /$ Defines the PromotionID for manual rebates $/
    attribute manualRebatePromotionID : String

    /$ Defies the PromotionId for manual points input $/
    attribute manualPointsPromotionID : String

    /$  true : the terminal is used for prepaid topup
        false: Webservice is used for prepaid actions $/
    attribute useTerminalForPrepaid : boolean

    /$ List of reasonCodes for complaint $/
    attribute complaintCodeList : String [ 0 .. * ]

    /$ List of special reasonCodes for complaint $/
    attribute specialComplaintReasonCodeList : String [ 0 .. * ]
    
    /$ Enabling / disabling of displaying the telephone number input screen during return process $/
    attribute showTelephoneNumber : boolean

    /$ additional ManualLineItemDiscountConfig for manual discount input  $/
    attribute manualLineItemDiscountConfig  : ManualLineItemDiscountConfig

    /$ additional ManualLineItemDiscountConfig for for manual bonus points input  $/
    attribute manualLineItemBonusPointsConfig  : ManualLineItemDiscountConfig

    /$ additional ManualLineItemDiscountConfig for new manual price input  $/
    attribute manualLineItemNewPriceConfig : ManualLineItemDiscountConfig

    /$ Return with transaction process config id $/
    attribute returnWithTransactionConfig_EXT  : ReturnWithTransactionConfigDO_EXT

    /$ List of another channels that are possible to be used for return with transaction $/
    attribute additionalHeadquartersForReturn : String [ 0 .. * ]
  }

typedef TestEnum : enum with type String [
    DefaultMode as "defaultMode",
    ValidationMode as "validationMode",
    NoPriceMode as "noPriceMode",
    ReturnMode as "returnMode"
]
}