dslLevel 2
Package com.gk_software.cst.pos.client.model.config.do_types.pos_process

Import com.gk_software.pos.api.model.config.do_types.processes.flows.ProcessConfig_DO.ProcessConfig
Import com.gk_software.pos.api.model.config.do_types.processes.ui.DialogConfig_DO.MessageDialogConfig
Import com.gk_software.cst.pos.client.model.config.do_types.pos_process.GiftCertificateCardTypeMappingConfig_CST.GiftCertificateCardTypeMappingConfigDO_CST


/$ This type defines the the return codes. $/
typedef ScgcTransferReturnCode_CST : enum with type String
[
  SUCCESSFUL_SCGC_TRANSFER           as "4",
  NOT_ENOUGH_SUPER_POINTS            as "2",
  NO_SCGC_PROMOTION                  as "0",
  SCGC_TRANSFER_RECLINED_BY_CUSTOMER as "3",
  NO_RETURN_CODE                     as ""           
]

 typedef ModeOfCallScgcTransferType_CST : enum with type String [   
    MANUAL  as "MANUAL",
    AUTOMATIC as "AUTOMATIC"
 ]

domain object ScgcTransferConfig_CST {
  version "1.0"
  
  master entity ScgcTransferConfigDO_CST extends ProcessConfig {
  
    /$ list of prefixes for supercash gift cards, separated by semicolon $/
    required attribute sCGCPrefix : String
    
    /$ Rounding is done to nearest multiple of SCGCpointsPrecision
       00 No rounding
       01 Round up if neighbors are equidistant (commercial rounding) 
       02 Round down 
       03 round up 
       04 Round down if neighbors are equidistant  $/
    required attribute sCGCpointsRoundMethod : String
    
    /$ valid intervalls for supercash points, precision of rounding, has to be a multiple of 1000 $/
    required attribute sCGCpointsPrecision : int
    
    /$ minimum value of supercash points
       - has to be a multiple of 1000
       - has to be a multiple of SCGCPointsRoundPrecision $/
    required attribute sGCPointsMin : int
    
    /$ maximum value of supercash points
       - has to be a multiple of 1000
       - has to be a multiple of SCGCpointsRoundPrecision
       - hast be >= SGCPointsMin $/
    required attribute sGCPointsMax : int
    
    /$ maximum value of supercash points transfered on one transaction
       - has to be a multiple of 1000
       - has to be a multiple of SCGCpointsRoundPrecision
       - hast be >= sGCPointsMax $/
    required attribute sGCTransactionPointsMax : int
    
    /$ Relevant for automatic call of SCGC transfer only
       true - supercard will be scanned a second time for comparison with first scanned supercard
       false - second scan of supercard is not necessar $/
    required attribute supercardVerificationEnabled : boolean
    
    /$ Relevant for manual call of SCGC transfer only
       true - supercard will be scanned a second time for comparison with first scanned supercard
       false - second scan of supercard is not necessar $/
    required attribute supercardVerificationForManualModEnabled :boolean
    
    /$ It defines the Stored Value Server instance to be used and contains the logical name of the adapter. $/
    required attribute externalSystemAdapterName : String
    
    /$ It defines the rating to calculate money equivalent of points. $/
    required attribute pointsRating : double  

    /$ Configuration for transfer abort confirm dialog. $/
    required attribute confirmTransferAbortMessageDialog: MessageDialogConfig
    
    /$ Configuration for transfer more points confirm dialog. $/
    required attribute confirmTransferMorePointsMessageDialog: MessageDialogConfig
    
    /$ Configuration for transfer points confirm dialog. $/
    required attribute confirmTransferPointsMessageDialog: MessageDialogConfig
    
    /$ Configuration for transfer points confirm dialog. $/
    required attribute scgcInvalidGCMessageDialog: MessageDialogConfig
    
    /$ GiftCertificate Mapping Configuration $/
    required attribute mappingConfig : GiftCertificateCardTypeMappingConfigDO_CST
    
    /$ Id of configuration for transaction canceling $/
    required attribute cancelTransactionConfig : String
    
    /$ Promotion discount method code $/
    required attribute promotionDiscountMethodCodes : String[0..*]
    
    /$ Promotion incentive code $/
    required attribute promotionIncentiveCode : String
    
    /$ Show abort transfer confirm dialog if some successful transfer is already done $/ 
    required attribute showAbortTransferConfirmDialogEveryTime : boolean 

    /$ scgc transfer feature enabled (relevant only for automatic mode, which is called after finishing of normal sale tx)
       true - super cash gift card transfer is active (turn on feature) 
       false - super cash gift card transfer is deactivated (turn off feature) 
    $/
    required attribute  transferScgcEnabled  : boolean
    
    /$ mode of call call scgc transfer function
       MANUAL - calling scgc transfer function by user (for example click on buttons)
       AUTOMATIC - calling scgc transfer function automaticly after finishing of normal sale tx 
    $/
    required attribute  modeOfCallScgcTransfer  : String
    
    /$ Configuration ID for supercard registration $/
    required attribute supercardRegistrationConfigId : String    

   
    /$ Creason code for SCGC line item $/
    attribute reasonCode : String
    
    /$ Creason code for SCGC line item $/
    attribute reasonType : String

  } 
  
}
