dslLevel 2

Package com.gk_software.cst.pos.client.model.config.do_types.pos_process

Import com.gk_software.pos.api.model.config.do_types.processes.flows.ProcessConfig_DO.ProcessConfig

domain object SupercardValidationConfig_CST {
	version "1.0"
	
	master entity SupercardValidationConfigDO_CST extends ProcessConfig {
	      
	  /$ defines if validation of points balance is enabled for supercard gift certificate $/
    attribute scgcTransferPointsValidationEnabled : boolean with default "true"
    
    /$ defines lower limit for points validation to pay with supercard gift certificate. from this limit up the points balance has to be validated. Value is in CHF. For example value of this parameter is  1.0 => 1.0 * 100 (default points rate) = 100 super points  $/
    attribute scgcTransferPointsValidationLowerLimit : double with default "1.0"
      
    /$ defines if validation of zip code is enabled for supercard gift certificate  $/
    attribute scgcTransferZipValidationEnabled : boolean with default "true"
    
    /$ defines lower limit for points validation to pay with supercard gift certificate. from this limit up the zip code has to be validated. Value is in CHF. For example value of this parameter is  1.0 => 1.0 * 100 (default points rate) = 100 super points  $/
    attribute scgcTransferZipValidationLowerLimit : double with default "1.0"
    
    /$ defines if validation of pin is enabled for supercard gift certificate  $/
    attribute scgcTransferPinValidationEnabled : boolean with default "true"
    
    /$ defines lower limit for count of points to with supercard gift certificate. from this limit up the pin has to be validated. Value is in CHF. For example value of this parameter is  1.0 => 1.0 *100 (default points rate) = 100 super points  $/
    attribute scgcTransferPinValidationLowerLimit : double with default "1.0"

    /$ defines if validation of points balance is enabled for tender points $/
    attribute pointsTenderPointsValidationEnabled : boolean with default "true"

    /$ defines lower limit for points validation to pay with tender points. from this limit up the points balance has to be validated. Value is in CHF. For example value of this parameter is  1.0 => 1.0 *100 (default points rate) = 100 super points  $/
    attribute pointsTenderPointsValidationLowerLimit : double with default "1.0"
   
    /$ defines if validation of zip code is enabled for tender points  $/
    attribute pointsTenderZipValidationEnabled : boolean with default "true"
    
    /$ defines lower limit for points validation to pay with tender points. from this limit up the zip code has to be validated. Value is in CHF. For example value of this parameter is  1.0 => 1.0 *100 (default points rate) = 100 super points  $/
    attribute pointsTenderZipValidationLowerLimit : double with default "1.0"
    
    /$ defines if validation of pin is enabled for tender points  $/
    attribute pointsTenderPinValidationEnabled : boolean with default "true"
    
    /$ defines lower limit for points validation to pay with tender points. from this limit up the pin has to be validated. Value is in CHF. For example value of this parameter is  1.0 => 1.0 *100 (default points rate) = 100 super points  $/
    attribute pointsTenderPinValidationLowerLimit : double with default "1.0"
    
    /$ defines if failed webservice call all types of validations are automatic passed    $/
    attribute resumeOnFailure : boolean with default "false"
    
    /$ maximum of allowed retry counts for pin input (e.g. pinMaxRetryCount = 2 means: Allowed are 3 attempts) $/
    attribute pinMaxRetryCount : int with default "2"  

    //OTHER
    /$ Defines how which input is used for pin entry. (true - OmniPos GUI mask with keyboard numpad , false - PinPad device) $/
    attribute pinWithKeyboard : boolean with default "true"  

    /$ Webservice configuration id. $/
    attribute adapterConfigId : String

    /$ SignalConfig for keyboard input dialog in supercard validation process $/
    attribute signalConfigId : String 

    /$ Default language used for validateSupercard webservice call $/
    attribute defaultLanguage : String
	}
}
