dslLevel 2

Package com.gk_software.cst.pos.client.model.config.do_types.pos_process

Import com.gk_software.pos.api.model.config.do_types.processes.actions.TerminalRegistrationConfig_DO.TerminalRegistrationConfig
Import com.gk_software.pos.api.model.config.do_types.processes.ui.DialogConfig_DO.DecisionDialogConfig
Import com.gk_software.pos.api.model.config.do_types.processes.ui.DialogConfig_DO.MessageDialogConfig
Import com.gk_software.pos.api.model.config.do_types.processes.flows.auth.AuthorizationConfig_DO.AuthorizationConfig
Import com.gk_software.pos.api.model.config.do_types.processes.actions.PositionOperationConfig_DO.PositionOperationConfig
Import com.gk_software.pos.api.model.config.do_types.processes.ui.DialogConfig_DO.PromptUserDialogConfig
Import com.gk_software.pos.api.model.config.do_types.processes.actions.PaymentOperationConfig_DO.PaymentOperationConfig
Import com.gk_software.pos.api.model.config.do_types.processes.flows.ProcessConfig_DO.ProcessConfig
Import com.gk_software.cst.pos.client.model.config.do_types.global.TwintConfig_CST.TwintConfigDO_CST

domain object TerminalTransactionConfig_CST {
  version "1.0"

    /$ Config for terminal payment process. $/
    master entity TerminalTransactionConfigDO_CST extends ProcessConfig {

        /$  The payment operation config for the terminal payment action $/
        required attribute paymentOperationConfig                   : PaymentOperationConfig

// Contents of TerminalPaymentOperationConfig from product - there is no reason why it has to be in a separate file
/////////////////////////////////////////////////////////////////////////////////////////////////////////////

        /$ Defines the device name for that payment operation $/
        required attribute deviceName : String

        /$ true - The merchant receipt is printed.
           false - The merchant receipt is not printed
       IMPORTANT: this value should only be changed in Default Config and not in spezialized Config since the Default is statically loaded in come code places$/
        required attribute  printMerchantReceipt : boolean

        /$ true - The merchant receipt is reprinted
        false (default) - The merchant receipt is not reprinted$/
       attribute reprintMerchantReceipt :boolean

        /$ default: false
      true:  a customer receipt will be printed separately from the sales receipt.
      false: no customer receipt will be printed separately from the sales receipt. $/
       required attribute printCustomerReceiptSeparately : boolean

        /$ ID of the ruleset in the file terminal_payment.xml $/
        required attribute terminalPaymentRulesId : String

        /$ ID of the ruleset in the file terminal_authorization.xml. $/
        required attribute terminalAuthorizationRulesId : String

        /$ true - A DCC transaction (Direct Currency Conversion) can be called on the terminal.
           false - Usual terminal payment is carried out. $/
        required attribute directCurrencyConversionMode : boolean

/////////////////////////////////////////////////////////////////////////////////////////////////////////////

        /$  Whether a refund transaction has to be done instead of cancellation of original transaction $/
        required attribute useRefundInsteadOfCancellation : boolean

        /$ Whether partial approval of the payment is possible (Davinci specific) $/
        required attribute partialApprovalPossible : boolean

        /$ Whether this is a payment with Davinci Paycard $/
        required attribute isPaycard : boolean

        /$ Whether an input field has to be shown (true) or only scanning of the paycard is allowed (false) $/
        required attribute paycardShowInputField : boolean

        /$ Comma separated list of paycard prefixes $/
        required attribute paycardBarcodePrefixes : String

        /$ Whether reversal can be used for terminal cancellations $/
        required attribute useReversal : boolean

        /$  The config for the prompt for terminal payment amount dialog $/
        required attribute promptForAmountConfig                    : PromptUserDialogConfig

        /$  The position operation config for the terminal payment action $/
        required attribute positionOperationConfig                  : PositionOperationConfig

        /$ The authorization for terminal event check security $/
        required attribute securityAuthorizationConfig              : AuthorizationConfig

        /$  Configuration of the confirm signature match dialog $/
        required attribute confirmSignatureMatchMessageConfig       : MessageDialogConfig

        /$  Configuration of the check event confirm dialog $/
        required attribute checkEventConfirmMessageConfig           : MessageDialogConfig

        /$  Configuration of the terminal offline confirmation $/
        required attribute confirmDialogOfflineTerminal             : MessageDialogConfig

        /$  Configuration of the merchant receipt printed confirmation $/
        required attribute confirmDialogMerchantPrintoutConfig      : MessageDialogConfig

        /$  Configuration of the payment failed message dialog $/
        required attribute paymentFailedMessageKey                  : String

        /$  Configuration of the payment failed message dialog $/
        required attribute paymentPleaseRetryKey                    : String

        /$  Configuration of the confirm manual error handling dialog $/
        required attribute confirmManualErrorHandlingMessageConfig  : MessageDialogConfig

        /$  Configuration of the decision result payment manually dialog $/
        required attribute decideResultPaymentManuallyConfig        : DecisionDialogConfig

        /$  Configuration of the decision DCC dialog $/
        required attribute decideDCCConfig                          : DecisionDialogConfig

        /$  Configuration of the event card insertion dialog $/
        required attribute eventCardInsertionMessageConfig          : MessageDialogConfig

        /$  Configuration of the event check reprint question dialog $/
        required attribute eventCheckReprintQuestionConfig          : MessageDialogConfig

        /$  Configuration of the keyboard request dialog $/
        required attribute promptForKeyboardRequestConfig           : PromptUserDialogConfig

        /$  Configuration of the confirmed string request dialog $/
        required attribute promptForConfirmedStringRequestConfig    : PromptUserDialogConfig

        /$  Configuration of the confirmed date time request dialog $/
        required attribute promptForConfirmedDatetimeRequestConfig  : PromptUserDialogConfig

        /$  Configuration of the continue cancel dialog $/
        required attribute eventCheckContinueCancelConfig           : MessageDialogConfig

        /$  Configuration of the decision key request dialog $/
        required attribute decideControlKeyRequestConfig            : DecisionDialogConfig

         /$  Configuration of the confirm teminal message dialog $/
        required attribute eventConfirmTerminalMessageConfig        : MessageDialogConfig

        /$  Terminal registration config $/
        required attribute terminalRegistrationConfig       : TerminalRegistrationConfig

        /$  Info about required signature $/
        required attribute showSignatureInfoConfig : MessageDialogConfig

        /$  Confirm signature or reprint dialog $/
        required attribute confirmReprintSignatureConfig : MessageDialogConfig

        /$  Terminal device id for training mode $/
        attribute trainingModeTerminalDeviceId : String with default '"VIRTUAL"'

        /$ Whether to save card number to TenderAuthorization $/
        required attribute saveCardNumber : boolean

        /$ Contracting company number which has to be filled to tender authorization ruws $/
        attribute contractingCompanyNumber : String

        /$ Specifies whether to disable signature message and confirmation dialogs $/
        attribute disableSignatureCheck : boolean
        
        /$ Specifies whether to use old or new implementation of CashAdvance $/
        attribute useLegacyCashAdvance : boolean
        
        /$ Defines whether the function Payment Terminal is started for TWINT $/
        required attribute paymentTwint : boolean

    // -- SCO only: -- //
    /$ Authorization for offline terminal $/
    required attribute scoAuthOfflineTerminal : AuthorizationConfig

    /$ Authorization for not enough money in till $/
        required attribute scoAuthNotEnoughMoneyInTill : AuthorizationConfig

    /$ Authorization for communication error $/
        required attribute scoAuthCommunicationError : AuthorizationConfig

    /$ Authorization for signature $/
        required attribute scoAuthSignature : AuthorizationConfig

    /$ Authorization for payment impossible $/
        required attribute scoAuthPaymentImpossible : AuthorizationConfig
}
}
