dslLevel 2
Package com.gk_software.cst.pos.client.model.config.do_types.report

Import com.gk_software.pos.api.model.config.do_types.component.client.CommonPrintoutConfig_DO.CommonPrintoutConfig
Import com.gk_software.cst.pos.client.model.config.do_types.report.TopUpTagFormatConfigDO_CST.TopUpTagFormatConfigDO_CST
Import com.gk_software.cst.pos.client.model.config.do_types.report.EProductTagFormatConfigDO_CST.EProductTagFormatConfigDO_CST

domain object CommonPrintoutConfig_EXT {
  version "1.0"
  master entity CommonPrintoutConfigDO_EXT extends CommonPrintoutConfig {

    /$ Specifies print report with operator $/
    attribute printReportWithOperator : boolean

    /$ Specifies print footer section $/
    attribute printDiscountFooter : boolean

    /$ Specifies whether name of the store should be printed $/
    attribute printHeaderCop : boolean

    /$ Specifies whether additional information (phone, fax, service) should be printed $/
    attribute printHeaderAddInfo : boolean

    /$ Excluded prefixes for promotion coupon $/
    attribute excludedPrefixes : String
    
    /$ Specifies which type of item number to use (ONLY for TG channel) $/
    attribute useItemNumberType : String

    /$ Specifies whether to use UOM description from tx extension or not (ONLY for TG channel) $/
    attribute useUOMDescription : boolean

    /$ Specifies tag formats for top up voucher $/
    attribute topUpTagFormatConfig : TopUpTagFormatConfigDO_CST

    /$ Specifies tag formats for EProduct $/
    attribute eProductTagFormatConfig : EProductTagFormatConfigDO_CST

    /$ Specifies whether money saved section should be printed or not $/
    attribute printMoneySaved : boolean

    /$ Specifies whether item count section should be printed or not $/
    attribute printItemCount : boolean

    /$ Property for excluding item types for counting $/
    attribute itemCountExcludedItemTypes : String [0 .. *]

    attribute saleReceiptBlocking : boolean

    attribute warrantyReceiptBlocking : boolean


    /$  $/
    attribute couponPictureFilePrefix : String

    /$  $/
    attribute couponBarcodePrefix : String

    /$  $/
    attribute couponQrUrl : String

    /$  $/
    attribute couponQrPrint : boolean

    /$  $/
    attribute couponQrCampaignID : String

    /$  $/
    attribute displayPrintChannel : boolean
    /$ Promotional ActionType for which a special symbol
      is displayed / printed. $/
    attribute nettoActionType : String [0 .. *]

    /$ List of exclusive card types for which the line with card type description is printed$/
    attribute exclusiveCardList : String
    /$ List of item types for which sap item number is printed$/
    attribute itemNumberPrintedSelection : String [0 .. *]
    
    /$ Image location path for coupon additional printouts $/
    required attribute couponImageFolder : String
    
    attribute printJournalWithArticleNumber : boolean
  }
}
